Package com.google.android.exoplayer2.source

## Interface MediaPeriod

- All Superinterfaces:
    `SequenceableLoader`
  All Known Implementing Classes:
    `ClippingMediaPeriod`, `FakeAdaptiveMediaPeriod`, `FakeMediaPeriod`, `HlsMediaPeriod`, `MaskingMediaPeriod`

      public interface MediaPeriod
      extends SequenceableLoader

  Loads media corresponding to a `Timeline.Period`, and allows that media to be read. All methods are called on the player's internal playback thread, as described in the `ExoPlayer` Javadoc.

  A `MediaPeriod` may only able to provide one `SampleStream` corresponding to a group at any given time, however this `SampleStream` may adapt between multiple tracks within the group.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `MediaPeriod.Callback` | A callback to be notified of `MediaPeriod` events.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `continueLoading​(long positionUs)` | Attempts to continue loading.
    `void` | `discardBuffer​(long positionUs, boolean toKeyframe)` | Discards buffered media up to the specified position.
    `long` | `getAdjustedSeekPositionUs​(long positionUs, SeekParameters seekParameters)` | Returns the position to which a seek will be performed, given the specified seek position and `SeekParameters`.
    `long` | `getBufferedPositionUs()` | Returns an estimate of the position up to which data is buffered for the enabled tracks.
    `long` | `getNextLoadPositionUs()` | Returns the next load time, or `C.TIME_END_OF_SOURCE` if loading has finished.
    `default List<StreamKey>` | `getStreamKeys​(List<ExoTrackSelection> trackSelections)` | Returns a list of `StreamKeys` which allow to filter the media in this period to load only the parts needed to play the provided `TrackSelections`.
    `TrackGroupArray` | `getTrackGroups()` | Returns the `TrackGroup`s exposed by the period.
    `boolean` | `isLoading()` | Returns whether the media period is currently loading.
    `void` | `maybeThrowPrepareError()` | Throws an error that's preventing the period from becoming prepared.
    `void` | `prepare​(MediaPeriod.Callback callback, long positionUs)` | Prepares this media period asynchronously.
    `long` | `readDiscontinuity()` | Attempts to read a discontinuity.
    `void` | `reevaluateBuffer​(long positionUs)` | Re-evaluates the buffer given the playback position.
    `long` | `seekToUs​(long positionUs)` | Attempts to seek to the specified position in microseconds.
    `long` | `selectTracks​(@NullableType ExoTrackSelection[] selections, boolean[] mayRetainStreamFlags, @NullableType SampleStream[] streams, boolean[] streamResetFlags, long positionUs)` | Performs a track selection.

- - ### Method Detail

    - #### prepare

          void prepare​(MediaPeriod.Callback callback,
                       long positionUs)

      Prepares this media period asynchronously.

      `callback.onPrepared` is called when preparation completes. If preparation fails, `maybeThrowPrepareError()` will throw an `IOException`.

      If preparation succeeds and results in a source timeline change (e.g. the period duration becoming known), `MediaSource.MediaSourceCaller.onSourceInfoRefreshed(MediaSource, Timeline)` will be called before `callback.onPrepared`.

      Parameters:
        `callback` - Callback to receive updates from this period, including being notified when preparation completes.
        `positionUs` - The expected starting position, in microseconds.

    - #### maybeThrowPrepareError

          void maybeThrowPrepareError()
                               throws IOException

      Throws an error that's preventing the period from becoming prepared. Does nothing if no such error exists.

      This method is only called before the period has completed preparation.

      Throws:
        `IOException` - The underlying error.

    - #### getTrackGroups

          TrackGroupArray getTrackGroups()

      Returns the `TrackGroup`s exposed by the period.

      This method is only called after the period has been prepared.

      Returns:
        The `TrackGroup`s.

    - #### getStreamKeys

          default List<StreamKey> getStreamKeys​(List<ExoTrackSelection> trackSelections)

      Returns a list of `StreamKeys` which allow to filter the media in this period to load only the parts needed to play the provided `TrackSelections`.

      This method is only called after the period has been prepared.

      Parameters:
        `trackSelections` - The `TrackSelections` describing the tracks for which stream keys are requested.
      Returns:
        The corresponding `StreamKeys` for the selected tracks, or an empty list if filtering is not possible and the entire media needs to be loaded to play the selected tracks.

    - #### selectTracks

          long selectTracks​(@NullableType ExoTrackSelection[] selections,
                            boolean[] mayRetainStreamFlags,
                            @NullableType SampleStream[] streams,
                            boolean[] streamResetFlags,
                            long positionUs)

      Performs a track selection.

      The call receives track `selections` for each renderer, `mayRetainStreamFlags` indicating whether the existing `SampleStream` can be retained for each selection, and the existing `stream`s themselves. The call will update `streams` to reflect the provided selections, clearing, setting and replacing entries as required. If an existing sample stream is retained but with the requirement that the consuming renderer be reset, then the corresponding flag in `streamResetFlags` will be set to true. This flag will also be set if a new sample stream is created.

      Note that previously passed `TrackSelections` are no longer valid, and any references to them must be updated to point to the new selections.

      This method is only called after the period has been prepared.

      Parameters:
        `selections` - The renderer track selections.
        `mayRetainStreamFlags` - Flags indicating whether the existing sample stream can be retained for each track selection. A `true` value indicates that the selection is equivalent to the one that was previously passed, and that the caller does not require that the sample stream be recreated. If a retained sample stream holds any references to the track selection then they must be updated to point to the new selection.
        `streams` - The existing sample streams, which will be updated to reflect the provided selections.
        `streamResetFlags` - Will be updated to indicate new sample streams, and sample streams that have been retained but with the requirement that the consuming renderer be reset.
        `positionUs` - The current playback position in microseconds. If playback of this period has not yet started, the value will be the starting position.
      Returns:
        The actual position at which the tracks were enabled, in microseconds.

    - #### discardBuffer

          void discardBuffer​(long positionUs,
                             boolean toKeyframe)

      Discards buffered media up to the specified position.

      This method is only called after the period has been prepared.

      Parameters:
        `positionUs` - The position in microseconds.
        `toKeyframe` - If true then for each track discards samples up to the keyframe before or at the specified position, rather than any sample before or at that position.

    - #### readDiscontinuity

          long readDiscontinuity()

      Attempts to read a discontinuity.

      After this method has returned a value other than `C.TIME_UNSET`, all `SampleStream`s provided by the period are guaranteed to start from a key frame.

      This method is only called after the period has been prepared and before reading from any `SampleStream`s provided by the period.

      Returns:
        If a discontinuity was read then the playback position in microseconds after the discontinuity. Else `C.TIME_UNSET`.

    - #### seekToUs

          long seekToUs​(long positionUs)

      Attempts to seek to the specified position in microseconds.

      After this method has been called, all `SampleStream`s provided by the period are guaranteed to start from a key frame.

      This method is only called when at least one track is selected.

      Parameters:
        `positionUs` - The seek position in microseconds.
      Returns:
        The actual position to which the period was seeked, in microseconds.

    - #### getAdjustedSeekPositionUs

          long getAdjustedSeekPositionUs​(long positionUs,
                                         SeekParameters seekParameters)

      Returns the position to which a seek will be performed, given the specified seek position and `SeekParameters`.

      This method is only called after the period has been prepared.

      Parameters:
        `positionUs` - The seek position in microseconds.
        `seekParameters` - Parameters that control how the seek is performed. Implementations may apply seek parameters on a best effort basis.
      Returns:
        The actual position to which a seek will be performed, in microseconds.

    - #### getBufferedPositionUs

          long getBufferedPositionUs()

      Returns an estimate of the position up to which data is buffered for the enabled tracks.

      This method is only called when at least one track is selected.

      Specified by:
        `getBufferedPositionUs` in interface `SequenceableLoader`
      Returns:
        An estimate of the absolute position in microseconds up to which data is buffered, or `C.TIME_END_OF_SOURCE` if the track is fully buffered.

    - #### getNextLoadPositionUs

          long getNextLoadPositionUs()

      Returns the next load time, or `C.TIME_END_OF_SOURCE` if loading has finished.

      This method is only called after the period has been prepared. It may be called when no tracks are selected.

      Specified by:
        `getNextLoadPositionUs` in interface `SequenceableLoader`

    - #### continueLoading

          boolean continueLoading​(long positionUs)

      Attempts to continue loading.

      This method may be called both during and after the period has been prepared.

      A period may call `SequenceableLoader.Callback.onContinueLoadingRequested(SequenceableLoader)` on the `MediaPeriod.Callback` passed to `prepare(Callback, long)` to request that this method be called when the period is permitted to continue loading data. A period may do this both during and after preparation.

      Specified by:
        `continueLoading` in interface `SequenceableLoader`
      Parameters:
        `positionUs` - The current playback position in microseconds. If playback of this period has not yet started, the value will be the starting position in this period minus the duration of any media in previous periods still to be played.
      Returns:
        True if progress was made, meaning that `getNextLoadPositionUs()` will return a different value than prior to the call. False otherwise.

    - #### isLoading

          boolean isLoading()

      Returns whether the media period is currently loading.
      Specified by:
        `isLoading` in interface `SequenceableLoader`

    - #### reevaluateBuffer

          void reevaluateBuffer​(long positionUs)

      Re-evaluates the buffer given the playback position.

      This method is only called after the period has been prepared.

      A period may choose to discard buffered media or cancel ongoing loads so that media can be re-buffered in a different quality.

      Specified by:
        `reevaluateBuffer` in interface `SequenceableLoader`
      Parameters:
        `positionUs` - The current playback position in microseconds. If playback of this period has not yet started, the value will be the starting position in this period minus the duration of any media in previous periods still to be played.